<?php
require_once(dirname(__FILE__).'/Info.php');
require_once(dirname(__FILE__).'/oauth/twitteroauth.php');

class TwitterDriver{
	/**
	 * 
	 * @param unknown_type $userID The application/system specific user id. (Not likely the same as the twitter user id.)
	 * @return The access token which consists of an array with values for
	 *         oauth_token, oauth_token_secret, tw_user_id, tw_screen_name
	 */
	public static function getAccessTokenForUser($userID){
		if(isset($userID)&&(strlen($userID)>0)){
			$result = mysql_query ('SELECT * FROM '.sql_table('twitter_users').' WHERE user=\''.mysql_real_escape_string($userID).'\'');
			$row = mysql_fetch_array($result);
		}
		return $row;
	}

	/**
	 * 
	 * @param $userID The application/system specific user id. (Not likely the same as the twitter user id.)
	 * @param $access_token The access token which consists of an array with values for
	 *                      oauth_token, oauth_token_secret, tw_user_id, tw_screen_name
	 * @return true if successful and false otherwise
	 */
	public static function setAccessTokenForUser($userID, $access_token){
		$success=false;
		if(isset($userID)&&(strlen($userID)>0)){
			$result = mysql_query ('SELECT * FROM '.sql_table('twitter_users').' WHERE user=\''.mysql_real_escape_string($userID).'\'');
			if($row = mysql_fetch_array($result)){
				$success = mysql_query ('UPDATE '.sql_table('twitter_users').' SET oauth_token=\''.mysql_real_escape_string($access_token['oauth_token']).'\', oauth_token_secret=\''.mysql_real_escape_string($access_token['oauth_token_secret']).'\', tw_user_id=\''.mysql_real_escape_string($access_token['user_id']).'\', tw_screen_name=\''.mysql_real_escape_string($access_token['screen_name']).'\' WHERE user=\''.mysql_real_escape_string($userID).'\'');
			}
			else{
				$success = mysql_query ('INSERT INTO '.sql_table('twitter_users').' SET oauth_token=\''.mysql_real_escape_string($access_token['oauth_token']).'\', oauth_token_secret=\''.mysql_real_escape_string($access_token['oauth_token_secret']).'\', tw_user_id=\''.mysql_real_escape_string($access_token['user_id']).'\', tw_screen_name=\''.mysql_real_escape_string($access_token['screen_name']).'\', user=\''.mysql_real_escape_string($userID).'\'');
			}
		}
		return $success;
	}

	/**
	 * 
	 * @param $token The access token which consists of an array with values for
	 *               oauth_token, oauth_token_secret, tw_user_id, tw_screen_name
	 */
	public static function isValidAccessToken($token){
		return (isset($token)&&isset($token['oauth_token'])&&isset($token['oauth_token_secret'])&&isset($token['tw_user_id'])&&isset($token['tw_screen_name']));
	}

	public static function sendRawTweet($msg,$access_token){
		global $TWITTER;
		/* Create a TwitterOauth object with consumer/user tokens. */
		$connection = new TwitterOAuth($TWITTER['CONSUMER_KEY'], $TWITTER['CONSUMER_SECRET'], $access_token['oauth_token'], $access_token['oauth_token_secret']);
		
		/* If method is set change API call made. Test is called by default. */
		return $connection->post('statuses/update', array('status' => $msg));
	}
}
?>